##################################################
##################################################
# R: A first look course
# Sheet 4: Data reporting
# IT Learning Centre, University of Oxford
# Graham Addis, 2022
# Srinivasa Rao, 2022
# Alex Homer, 2021
##################################################
##################################################

#### EXERCISE 12 ####

# This is code using a dataset called "iris", which is
# another of the sample datasets.  This time we are just
# going to load it from the built-in datasets, instead of a
# CSV file.  Type "?iris" into the console to learn more
# about it.*

# The code does several things using the techniques you've
# learnt in the previous sheets, as well as some things you
# haven't seen.
#
# Run the code and write a comment, starting with "#", about
# each line saying what that line does. (The first line, and
# the lines that do something novel, are completed for you.)

# Loads the dataset "iris"
my_iris <- iris

#
head(my_iris)

#
summary(my_iris)

# Creates a "pairs plot" across the continuous variables,
# omitting the "species" column
plot(my_iris[, -5])

#
spec_tab <- table(my_iris$Species)

#
barplot(
     spec_tab,
     xlab = "Species",
     ylab = "Frequency"
     )

#
apply(my_iris[, -5], 2, sd)

#
my_iris$Sepal.Ratio <- my_iris$Sepal.Length / my_iris$Sepal.Width
my_iris$Petal.Ratio <- my_iris$Petal.Length / my_iris$Petal.Width

#
boxplot(
     my_iris$Sepal.Ratio,
     my_iris$Petal.Ratio,
     names = c("Sepal ratio", "Petal ratio")
     )

#
plot(
     my_iris$Sepal.Ratio,
     my_iris$Petal.Ratio,
     xlab = "Sepal ratio",
     ylab = "Petal ratio"
     )


#
#
plot(
     my_iris$Sepal.Ratio,
     my_iris$Petal.Ratio,
     xlab = "Sepal ratio",
     ylab = "Petal ratio",
     col = my_iris$Species
     )

# Adds a legend for the colours: the colours used are
# colours 1, 2 and 3, colouring the species in the order
# that they first appear in the data frame
legend(
     "topright",
     legend = c("setosa", "versicolor", "virginica"),
     col = 1:3,
     pch = 1
     )

#
my_iris_vir <- my_iris[my_iris$Species == "virginica", ]

#
plot(
     my_iris_vir$Sepal.Ratio,
     my_iris_vir$Petal.Ratio,
     xlab = "Sepal ratio",
     ylab = "Petal ratio",
     main = "Virginica only"
     )

# For people who looked at optional section 3.3 on linear models:

#
mod_rat <- lm(Petal.Ratio ~ Sepal.Ratio, data = my_iris_vir)

#
summary(mod_rat)

#
abline(mod_rat, col = "hotpink", lty = 4)

# * As a note, I have heard that irises do not have petals
# or sepals, instead having things that defy categorisation,
# known as "tepals".

#4.2 (Optional) R Markdown

# R Markdown is a way of writing R code and text together in
# one document, so that it can be output into a nice format.
# This course isn't going to attempt to teach you R
# Markdown, but it's a useful thing to know exists!  (I knew
# R for many years before I'd heard of it, and it would have
# made my life much easier in several settings.)

# EXERCISE 12A

# Open the notes.Rmd file.  Have a look at the code and see
# if you can understand what's going on. (You don't have to
# write anything.)
